import java.awt.*;

public class DrawingAirbus extends DrawingPlane
{
    private Color addColor;

    //Конструктор
    public DrawingAirbus(int speed, int weight, Color corpusColor, int countWindow, Color addColor, boolean addCompartment, boolean addEngine)
    {
        super(speed, weight, corpusColor, countWindow, 70, 30);
        Plane = new EntityAirbus(speed, weight, corpusColor, addColor, addCompartment, addEngine);
        this.addColor = addColor;
    }

    //Второй конструктор
    public DrawingAirbus(EntityPlane plane, IAdditionalDrawingObject addWindows)
    {
        super(plane, addWindows);
        Plane = plane;
    }

    public void SetAddColor(Color color)
    {
        var temp = (EntityAirbus) Plane;
        Plane = new EntityAirbus(temp.GetSpeed(), temp.GetWeight(), temp.GetColor(), color,
                temp.AddCompartment(), temp.AddEngine());
        addColor = color;
    }

    @Override
    public void SetColor(Color color)
    {
        var temp = (EntityAirbus) Plane;
        addColor = addColor == null ? Color.WHITE : addColor;
        Plane = new EntityAirbus(temp.GetSpeed(), temp.GetWeight(), color, addColor, temp.AddCompartment(), temp.AddEngine());
    }

    @Override
    public void DrawTransport(Graphics g)
    {
        Graphics2D g2d = (Graphics2D) g;
        EntityAirbus airbus;

        if (!(GetPlane() instanceof EntityAirbus))
        {
            return;
        }

        airbus = (EntityAirbus) Plane;
        _startPosX += 10;
        _startPosY += 5;
        super.DrawTransport(g);
        _startPosX -= 10;
        _startPosY -= 5;

        //дополнительный пассажирский отсек
        if (airbus.AddCompartment())
        {
            g2d.setPaint(airbus.AddColor());
            g2d.fillRect((int)_startPosX + 30, (int)_startPosY + 12, 14, 3);
            g2d.setPaint(Color.BLACK);
            g2d.drawRect((int)_startPosX + 30, (int)_startPosY + 12, 14, 3);
        }

        //дополнительный двигатель
        if (airbus.AddEngine())
        {
            g2d.setPaint(airbus.AddColor());
            g2d.fillOval((int)_startPosX + 24, (int)_startPosY + 22, 10, 5);
            g2d.setPaint(Color.BLACK);
            g2d.drawOval((int)_startPosX + 24, (int)_startPosY + 22, 10, 5);
        }

        super.repaint();
    }
}
