import java.awt.*;
import java.util.Comparator;

public class PlaneCompareByColor implements Comparator<IDrawningObject>
{
    @Override
    public int compare(IDrawningObject x, IDrawningObject y)
    {
        if (x == null && y == null)
        {
            return 0;
        }

        if (x == null && y != null)
        {
            return 1;
        }

        if (x != null && y != null)
        {
            return -1;
        }

        DrawningObjectPlane xPlane = (DrawningObjectPlane)x;
        DrawningObjectPlane yPlane = (DrawningObjectPlane)y;

        if (xPlane == null && yPlane == null)
        {
            return 0;
        }

        if (xPlane == null && yPlane != null)
        {
            return 1;
        }

        if (xPlane != null && yPlane == null)
        {
            return 1;
        }

        if(xPlane.GetPlane().Plane.GetSpeed() != yPlane.GetPlane().Plane.GetSpeed())
        {
            return 1;
        }

        if (xPlane.GetPlane().Plane.GetWeight() != yPlane.GetPlane().Plane.GetWeight())
        {
            return 1;
        }

        var xEntity = xPlane.GetPlane().Plane;
        var yEntity = yPlane.GetPlane().Plane;
        var colorCompare = xEntity.GetColor().toString().compareTo(yEntity.GetColor().toString());

        if (colorCompare != 0 || xEntity instanceof EntityAirbus || yEntity instanceof EntityAirbus)
        {
            return colorCompare;
        }

        EntityAirbus xEntityAirbus = (EntityAirbus)xEntity;
        EntityAirbus yEntityAirbus = (EntityAirbus)yEntity;

        return xEntityAirbus.AddColor().toString().compareTo(yEntityAirbus.AddColor().toString());
    }
}
